VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsLevel"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Option Compare Binary
Option Base 0


Public ptrHeader As Long

Public Width As Integer
Public Height As Integer

Public camX As Integer
Public camY As Integer

Public playerX As Integer
Public playerY As Integer

Private ptrBlockmap As Long
Public blockWidth As Integer
Public blockHeight As Integer

Private Objects() As clsObject
Public objectCount As Long

Private ptrMap As Long
Private Map() As Byte

Private Sprites() As clsSprite

Public World As clsWorld


Public Function getSprite(ByVal Index As Long) As clsSprite

    If Index < 0 Or Index > 15 Then Exit Function
    
    Set getSprite = Sprites(Index)

End Function


' Load sprites from a configuration file
Public Function loadSprites(ByRef Dict As Dictionary) As Boolean
    
    Dim A As Long
    Dim nDict As Dictionary
    Dim Index As Long

    
    For A = 0 To Dict.Count - 1
        Set nDict = Dict.Items(A)
        Index = Dict.Keys(A)

        Set Sprites(Index) = New clsSprite
        Sprites(Index).loadFrom nDict
    Next A

End Function


' Return object at location
Public Function pickObject(ByVal X As Long, ByVal Y As Long) As clsObject

    Dim A As Long
    
    
    For A = 0 To objectCount - 1
        If X >= Objects(A).X And X < Objects(A).X + 1 Then
            If Y >= Objects(A).Y And Y < Objects(A).Y + 1 Then
                Set pickObject = Objects(A)
                Exit Function
            End If
        End If
    Next A

End Function


Public Function getTile(ByVal X As Long, ByVal Y As Long) As Byte

    If X < 0 Or X > Width Or Y < 0 Or Y > Height Then Exit Function
    
    getTile = Map(X, Y)

End Function


Public Function Render(Ctx As clsRenderContext)
    
    Dim A As Long
    Dim X As Long, Y As Long
    Dim rX As Long, rY As Long
    
    Dim tX As Long, tY As Long
    Dim sX As Long, sY As Long
    Dim rWidth As Long, rHeight As Long
    
    Dim Sprite As clsSprite
    Dim subSprite As clsSubSprite
    Dim objX As Long, objY As Long
    Dim Surface As clsSurface
    Dim objName As String
    
    Dim COL_OBJECT As Long
    Dim COL_HIGHLIGHT As Long
    Dim COL_TEXT As Long
    Dim COL_GRID As Long
    Dim COL_CAMERA As Long
    Dim COL_PLAYER As Long
        

    COL_OBJECT = createBGRA(0, 255, 0, 0)
    COL_HIGHLIGHT = createBGRA(255, 0, 0, 0)
    COL_TEXT = createBGRA(255, 255, 255, 31)
    COL_GRID = createBGRA(127, 127, 127, 0)
    COL_CAMERA = createBGRA(255, 255, 0, 0)
    COL_PLAYER = createBGRA(255, 255, 0, 0)
    
    ' Camera\rendering coordinates
    tX = Ctx.Camera.X \ TILESIZE
    tY = Ctx.Camera.Y \ TILESIZE
    sX = Ctx.Camera.X Mod TILESIZE
    sY = Ctx.Camera.Y Mod TILESIZE

    ' Map area
    rWidth = Ctx.BackBuffer.Width \ TILESIZE + 1
    rHeight = Ctx.BackBuffer.Height \ TILESIZE + 1
    
    ' Do not render outside (small) maps
    If rHeight > Height - 1 Then rHeight = Height - 1
    If rWidth > Width - 1 Then rWidth = Width - 1
    If rWidth + tX > Width - 1 Then rWidth = Width - tX - 1
    If rHeight + tY > Height - 1 Then rHeight = Height - tY - 1

    ' Map tiles
    For Y = 0 To rHeight
        For X = 0 To rWidth

            If Map(X + tX, Y + tY) <= World.Tiles.nTiles Then
                If Ctx.renderCollision Then
                    Set Surface = World.Tiles.collisionTile(Map(X + tX, Y + tY))
                Else
                    Set Surface = World.Tiles.Tile(Map(X + tX, Y + tY))
                End If

                If Not Surface Is Nothing Then renderBlitFast Ctx.BackBuffer.ptrSurface, Surface.ptrSurface, X * TILESIZE - sX, Y * TILESIZE - sY
            End If

        Next X
    Next Y
        
    
    ' Grid
    If Ctx.renderGrid Then
        For X = 0 To rWidth
            renderLine Ctx.BackBuffer.ptrSurface, X * TILESIZE - sX, 0, X * TILESIZE - sX, (rHeight + 1) * TILESIZE, COL_GRID, BLEND_INVERT
        Next X
        For Y = 0 To rHeight
            renderLine Ctx.BackBuffer.ptrSurface, 0, Y * TILESIZE - sY, (rWidth + 1) * TILESIZE, Y * TILESIZE - sY, COL_GRID, BLEND_INVERT
        Next Y
    End If
        

    ' Objects
    If Ctx.renderObjects Then
    
        rWidth = Ctx.BackBuffer.Width \ 8 + 1
        rHeight = Ctx.BackBuffer.Height \ 8 + 1
        tX = Ctx.Camera.X \ 8
        tY = Ctx.Camera.Y \ 8
        
        For A = 0 To objectCount - 1
            If Objects(A).X > tX - 8 And Objects(A).X < tX + rWidth + 1 + 8 Then
                If Objects(A).Y > tY - 8 And Objects(A).Y < tY + rHeight + 1 + 8 Then
                
                    objX = Objects(A).X * 8 - Ctx.Camera.X
                    objY = Objects(A).Y * 8 - Ctx.Camera.Y
                    
                    If Ctx.renderCaptions Then renderBoxFill Ctx.BackBuffer.ptrSurface, objX, objY, 8, 8, COL_OBJECT, BLEND_ALPHA50
                    
                    ' Get sprite
                    Set Sprite = Sprites(Objects(A).Sprite)
                    If Not Sprite Is Nothing Then
                        objName = UCase$(Sprite.Name)
                    
                        ' Get subsprite
                        Set subSprite = Sprite.getSubSprite(Objects(A).subSprite)
                        If Not subSprite Is Nothing Then
                            
                            ' Get graphic
                            If Not subSprite.Graphic Is Nothing Then
                                Set Surface = subSprite.Graphic.Image(subSprite.graphicIndex)
                                If Not Surface Is Nothing Then renderBlitAlphaFast Ctx.BackBuffer.ptrSurface, Surface.ptrSurface, objX + subSprite.offsetX, objY + subSprite.offsetY, BLEND_ALPHA_SIMPLE
                            End If
                            objName = objName & " " & UCase$(subSprite.Name)
                        End If
                        
                    Else
                        objName = Objects(A).Sprite & "/" & Objects(A).subSprite
                        
                    End If
                    
                    ' Caption
                    If Ctx.renderCaptions Then
                        objName = Trim$(objName)
                        renderText Ctx.BackBuffer.ptrSurface, rFont.ptrFont, objX, objY - 8, objName, COL_TEXT, BLEND_ALPHA
                    End If
                    If Ctx.Highlight = A Then renderBox Ctx.BackBuffer.ptrSurface, objX - 1, objY - 1, 10, 10, COL_HIGHLIGHT, BLEND_SOLID
                    
                End If
            End If
        Next A
        
    End If
    
    ' Starting location
    If Ctx.renderStart Then
        tX = ((camX + 1) * TILESIZE) - Ctx.Camera.X
        tY = ((camY + 1) * TILESIZE) - Ctx.Camera.Y
        
        renderBox Ctx.BackBuffer.ptrSurface, tX, tY, 304, 192, COL_CAMERA, BLEND_SOLID
        renderBoxFill Ctx.BackBuffer.ptrSurface, tX + playerX - TILESIZE, tY + playerY - TILESIZE, 29, 36, COL_PLAYER, BLEND_ALPHA50
    End If

End Function


' Load this level from a bitstream
Public Function loadFrom(ByVal Index As Long, ByRef Bits As clsBitStream, ByRef mapBits As clsBitStream, ByVal Offset As Long) As Boolean

    Dim A As Long
    Dim X As Long, Y As Long
    
    Dim Count As Long
    Dim Sprite As Byte
    Dim subSprite As Byte
    
    Dim myBit As clsBitStream
    
    
    ' Header
    ptrMap = Bits.getLong - DATAOFFSET
    Width = Bits.getInteger
    Height = Bits.getInteger

    camX = Bits.getInteger
    camY = Bits.getInteger

    playerX = Bits.getInteger
    playerY = Bits.getInteger

    blockWidth = Bits.getInteger
    blockHeight = Bits.getInteger

    Bits.skipBytes 20
    ptrBlockmap = Bits.getLong - DATAOFFSET
    Bits.skipBytes 6
    
    
    ' Blockmap
    ' Calculate list count by first offset
    Bits.seekTo ptrBlockmap
    Count = (Bits.getLong - DATAOFFSET - ptrBlockmap) / 4
    ReDim Offsets(Count - 1)
    
    ' Read item block list offsets
    Bits.seekTo ptrBlockmap
    For A = 0 To Count - 1
        Offsets(A) = Bits.getLong - DATAOFFSET
    Next A

    ' Read item coordinates \ blockmap
    ' Each offset points to a list of items
    ' Each list contains the type of item and the X and the Y coordinate within the block of the map it describes
    ' Each list is terminated with 0xFF
    ' Blocks go from left to right, top to bottom, 32x32 subtiles in size
    objectCount = 0
    X = 0
    Y = 0
    For A = 0 To Count - 1
        Bits.seekTo Offsets(A)

        Do
            subSprite = Bits.getBits(4)
            Sprite = Bits.getBits(4)
            If Sprite = 15 And subSprite = 15 Then Exit Do
            
            ReDim Preserve Objects(objectCount)
            objectCount = objectCount + 1
            Set Objects(objectCount - 1) = New clsObject

            With Objects(objectCount - 1)
                .Index = objectCount - 1
                .Sprite = Sprite
                .subSprite = subSprite
                .Address = Bits.getAddress - 1
                .X = Bits.getByte + (X * BMAP_WIDTH) - 4
                .Y = Bits.getByte + (Y * BMAP_HEIGHT)
            End With

        Loop
        
        ' Advance block
        X = X + 1
        If X > blockWidth Then
            X = 0
            Y = Y + 1
        End If
        
    Next A
    
    
    ' Map
    If Index = 0 Then
        Set myBit = Bits
        myBit.seekTo ptrMap + Offset
    Else
        Set myBit = mapBits
        myBit.seekTo Offset
    End If
    
    ReDim Map(Width - 1, Height - 1)
    For X = 0 To Width - 1
        For Y = 0 To Height - 1
            Map(X, Y) = myBit.getByte
        Next Y
    Next X
    
    
    loadFrom = True

End Function


Private Sub Class_Initialize()

    ReDim Sprites(15)

End Sub
