VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPalette"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Option Compare Binary
Option Base 0


' Palette data
Private Palette() As Long
Public Entries As Long


' Construct grayscale palette
Public Sub Grayscale(ByVal Count As Long)

    Dim Index As Long
    Dim V As Long
    
    
    ReDim Palette(255)
    For Index = 0 To Count - 1
        V = ((256 / Count) * (Index + 1)) - 1
        Palette(Index) = createBGRA(V, V, V, 255)
    Next Index

End Sub


Public Function ptrPal() As Long

    ptrPal = VarPtr(Palette(0))

End Function


' Add a new entry to the palette
Public Sub addEntry(ByVal Color As Long)

    ReDim Preserve Palette(Entries)
    Entries = Entries + 1
    
    Palette(Entries - 1) = Color

End Sub


' Return a palette value
Public Function Entry(ByVal Index As Long) As Long

    Entry = Palette(Index)

End Function


' Load palette data from a bitstream
Public Function loadFrom(ByRef bitStream As clsBitStream, ByVal nEntries As Long) As Boolean

    Dim A As Long


    Entries = nEntries
    ReDim Palette(255)

    For A = 0 To Entries - 1
        bitStream.getBits 4
        Palette(A) = createBGRA(bitStream.getBits(4) * 17, bitStream.getBits(4) * 17, bitStream.getBits(4) * 17, 0)
    Next A
    
    loadFrom = True

End Function
