VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsSurface"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Option Compare Binary
Option Base 0


Public ptrSurface As Long

Public Width As Long
Public Height As Long


' Write surface to PNG file
Public Function writeToPNG(ByVal fileName As String, ByVal Compression As Byte) As Boolean

    If surfaceWriteToPNG(ptrSurface, fileName, Compression) = 1 Then Exit Function
    
    writeToPNG = True

End Function


' Flip surface vertically
Public Function flipY() As clsSurface

    Dim ptrNew As Long
    
    
    ptrNew = surfaceFlipY(ptrSurface)
    If ptrNew = 0 Then Exit Function
    
    Set flipY = New clsSurface
    flipY.ptrSurface = ptrNew
    flipY.Width = surfaceGetWidth(flipY.ptrSurface)
    flipY.Height = surfaceGetHeight(flipY.ptrSurface)

End Function


' Extract a portion of this surface into a new one
Public Function extractSurface(ByVal X As Long, ByVal Y As Long, ByVal Width As Long, ByVal Height As Long) As clsSurface

    Set extractSurface = New clsSurface
    extractSurface.Create Width, Height
    
    surfaceExtract ptrSurface, extractSurface.ptrSurface, X, Y

End Function


' Create a new surface
Public Function Create(ByVal newWidth As Long, ByVal newHeight As Long) As Boolean

    surfaceDestroy ptrSurface
    
    ptrSurface = surfaceCreate(newWidth, newHeight)
    If ptrSurface = 0 Then Exit Function
    
    Width = newWidth
    Height = newHeight
    
    Create = True

End Function


' Load a surface from a file
Public Function loadFromFile(ByVal fileName As String) As Boolean
    
    surfaceDestroy ptrSurface
    
    ptrSurface = surfaceReadFromPNG(fileName)
    If ptrSurface = 0 Then Exit Function
    
    Width = surfaceGetWidth(ptrSurface)
    Height = surfaceGetHeight(ptrSurface)
    
    loadFromFile = True

End Function


Private Sub Class_Terminate()
    
    surfaceDestroy ptrSurface
    
    ptrSurface = 0

End Sub

