VERSION 5.00
Begin VB.Form frmAbout 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00000000&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "About"
   ClientHeight    =   7665
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   9585
   ControlBox      =   0   'False
   BeginProperty Font 
      Name            =   "Segoe UI"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmAbout.frx":0000
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   511
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   639
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdClose 
      Cancel          =   -1  'True
      Caption         =   "Close"
      Height          =   435
      Left            =   6840
      TabIndex        =   0
      Top             =   7020
      Width           =   2535
   End
   Begin VB.CommandButton cmdBench 
      Caption         =   "Benchmark"
      Height          =   435
      Left            =   240
      TabIndex        =   1
      Top             =   7020
      Width           =   2535
   End
End
Attribute VB_Name = "frmAbout"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Compare Binary
Option Base 0


Private BackBuffer As clsBackBuffer
    
Private Logo As clsSurface
Private subLogo As clsSurface

Private rFont As clsFont


Private Sub cmdBench_Click()

    Dim A As Long
    Dim Timer As clsTimer
    Dim opCount As Long
    Dim Msg As String
    Dim COL_BENCH As Long
    
    Dim opsBlit As Long
    Dim opsBlitFast As Long
    Dim opsBlitAlphaFast As Long
    Dim opsBoxFill As Long
    Dim opsText As Long
    
    
    opCount = 15000
    COL_BENCH = createBGRA(127, 127, 127, 127)
    
    
    Set Timer = New clsTimer
    
    ' BlitFast
    Timer.timerStart
    For A = 1 To opCount
        renderBlitFast BackBuffer.ptrSurface, Logo.ptrSurface, 0, 0
    Next A
    opsBlitFast = opCount / (Timer.timerEnd / 1000)
    Msg = Msg & "BlitFast: " & opsBlitFast & vbCrLf
    
    ' BlitFastAlpha
    Timer.timerStart
    For A = 1 To opCount
        renderBlitAlphaFast BackBuffer.ptrSurface, Logo.ptrSurface, 0, 0, BLEND_ALPHA
    Next A
    opsBlitAlphaFast = opCount / (Timer.timerEnd / 1000)
    Msg = Msg & "BlitAlphaFast: " & opsBlitAlphaFast & vbCrLf
    
    ' Blit
    Timer.timerStart
    For A = 1 To opCount
        renderBlit BackBuffer.ptrSurface, Logo.ptrSurface, 0, 0, 128, 128, BLEND_ALPHA
    Next A
    opsBlit = opCount / (Timer.timerEnd / 1000)
    Msg = Msg & "Blit: " & opsBlit & vbCrLf
    
    ' RenderBoxFill
    Timer.timerStart
    For A = 1 To opCount
        renderBoxFill BackBuffer.ptrSurface, 0, 0, 64, 64, COL_BENCH, BLEND_ALPHA
    Next A
    opsBoxFill = opCount / (Timer.timerEnd / 1000)
    Msg = Msg & "BoxFill: " & opsBoxFill & vbCrLf
    
    ' RenderText
    Timer.timerStart
    For A = 1 To opCount
        renderText BackBuffer.ptrSurface, rFont.ptrFont, 0, 0, "Pa's Wijze Lynx Bezag Vroom Het Fikse Aquaduct", COL_BENCH, BLEND_ALPHA
    Next A
    opsText = opCount / (Timer.timerEnd / 1000)
    Msg = Msg & "Text: " & opsText & vbCrLf
    
    MsgBox Msg

End Sub


Private Sub cmdClose_Click()

    Me.Hide

End Sub


Private Sub Form_Load()

    Dim A As Long
    Dim Text() As String
    Dim nText As Long
    
    Dim Bits As clsBitStream
    Dim logoBP As clsBitplane
    Dim sublogoBP As clsBitplane
    Dim logoPal As clsPalette
    
    Dim COL_TEXT As Long
    
    
    COL_TEXT = createBGRA(255, 255, 255, 255)
    
    
    Set BackBuffer = New clsBackBuffer
    BackBuffer.Create Me.ScaleWidth / 2, Me.ScaleHeight / 2, 2
    
    
    ' Read graphics
    Set logoBP = New clsBitplane
    Set sublogoBP = New clsBitplane
    Set logoPal = New clsPalette
    
    Set Bits = New clsBitStream
    Bits.fileOpen APP_PATH & "gamedata\IDAT"
    
    logoBP.loadPlanar Bits, 320, 116, 4
    sublogoBP.loadPlanar Bits, 64, 49, 4


    ' Read palette
    Set Bits = New clsBitStream
    Bits.fileOpen APP_PATH & "gamedata\INTR"
    
    Bits.seekTo 1404
    logoPal.loadFrom Bits, 16
    
    
    ' Convert bitplanes to surfaces
    Set Logo = logoBP.toSurface(Nothing, logoPal.ptrPal, 0, 0)
    Set subLogo = sublogoBP.toSurface(Nothing, logoPal.ptrPal, 0, 0)
    
    
    ' Load font
    Set rFont = New clsFont
    rFont.loadFromFile APP_PATH & "fonts\turrican.png"
    
    
    ' Render
    renderBlitFast BackBuffer.ptrSurface, Logo.ptrSurface, 0, 0
    renderBlitFast BackBuffer.ptrSurface, subLogo.ptrSurface, 128, 64
    
    ReDim Text(3)
    nText = 4
    Text(0) = "Turrican II Spy"
    Text(1) = APP_VERSION
    Text(2) = vbNullString
    Text(3) = "By Dennis ""Exl"" Meuwissen"
    
    For A = 0 To nText - 1
        renderText BackBuffer.ptrSurface, rFont.ptrFont, 160 - ((Len(Text(A)) * rFont.charWidth) / 2), 144 + A * (rFont.charHeight + 2), UCase$(Text(A)), COL_TEXT, BLEND_ALPHA
    Next A
    
    BackBuffer.Present frmAbout.hDC
    frmAbout.Refresh
    
End Sub
