VERSION 5.00
Begin VB.Form frmGraphics 
   Caption         =   "Graphics"
   ClientHeight    =   9855
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   16635
   BeginProperty Font 
      Name            =   "Segoe UI"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmGraphics.frx":0000
   ScaleHeight     =   657
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   1109
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdExportAll 
      Caption         =   "Export all"
      Height          =   435
      Left            =   180
      TabIndex        =   1
      Top             =   8520
      Width           =   2355
   End
   Begin VB.PictureBox picRender 
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      Height          =   9795
      Left            =   2700
      ScaleHeight     =   653
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   929
      TabIndex        =   4
      TabStop         =   0   'False
      Top             =   0
      Width           =   13935
   End
   Begin VB.CommandButton cmdExit 
      Cancel          =   -1  'True
      Caption         =   "Exit"
      Height          =   435
      Left            =   180
      TabIndex        =   2
      Top             =   9060
      Width           =   2355
   End
   Begin VB.Frame framControls 
      BorderStyle     =   0  'None
      Height          =   8355
      Left            =   60
      TabIndex        =   3
      Top             =   60
      Width           =   2535
      Begin VB.ListBox lstGraphics 
         Height          =   6690
         Left            =   180
         Sorted          =   -1  'True
         TabIndex        =   0
         Top             =   180
         Width           =   2175
      End
      Begin VB.Label lblInfo 
         Caption         =   "Info"
         Height          =   855
         Left            =   300
         TabIndex        =   5
         Top             =   7140
         Width           =   1875
      End
   End
End
Attribute VB_Name = "frmGraphics"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Compare Binary
Option Base 0


Private Buffer As clsBackBuffer
Private List As clsSurfaceList


Private Sub cmdExit_Click()

    Me.Hide

End Sub


Private Sub cmdExportAll_Click()

    Dim Index As Long
    Dim Surf As clsSurface
    Dim Graphic As clsSurfaceList
    
    
    If Not FS.FolderExists(APP_PATH & "graphics") Then FS.CreateFolder APP_PATH & "graphics"
    
    ' Write composed surfaces
    For Index = 0 To Graphics.Count - 1
        Set Graphic = Graphics.Items(Index)
        Set Surf = Graphic.Compose
        Surf.writeToPNG APP_PATH & "graphics\" & Graphic.Name & ".png", 5
    Next Index
    
    MsgBox "All graphics exported to graphics\.", vbInformation Or vbOKOnly
    
End Sub


Private Sub Form_Load()

    Dim Index As Long
    
    
    lstGraphics.Clear
    For Index = 0 To Graphics.Count - 1
        lstGraphics.AddItem Graphics.Keys(Index)
    Next Index
    
    Form_Resize
    lstGraphics.ListIndex = 0

End Sub


Private Sub Form_Resize()

    On Error GoTo Abort

    picRender.Width = Me.ScaleWidth - (framControls.Left + framControls.Width) - 3
    picRender.Height = Me.ScaleHeight
    
    Set Buffer = New clsBackBuffer
    Buffer.Create picRender.Width / 2, picRender.Height / 2, 2
    
    Render
    
Abort:
    Exit Sub
    
End Sub


Private Sub Render()

    Dim Index As Long
    Dim X As Long, Y As Long
    
    
    ' Checkered background
    For X = 0 To Buffer.Width / Checkers.Width
        For Y = 0 To Buffer.Height / Checkers.Height
            renderBlitFast Buffer.ptrSurface, Checkers.ptrSurface, X * Checkers.Width, Y * Checkers.Height
        Next Y
    Next X
    
    ' Surface list
    If Not List Is Nothing Then
        X = 1
        Y = 1
        
        For Index = 0 To List.nImages - 1
            renderBlitAlphaFast Buffer.ptrSurface, List.Image(Index).ptrSurface, X, Y, BLEND_ALPHA_SIMPLE
            
            X = X + List.maxWidth + 1
            If X + List.maxWidth + 1 > Buffer.Width Then
                X = 1
                Y = Y + List.maxHeight + 1
            End If
        Next Index
        
        lblInfo.Caption = "Width: " & List.maxWidth & vbCrLf & "Height: " & List.maxHeight & vbCrLf & "Count: " & List.nImages
    Else
        lblInfo.Caption = vbNullString
    End If
    
    ' Present
    Buffer.Present picRender.hDC
    picRender.Refresh

End Sub


Private Sub lstGraphics_Click()
    
    Set List = Graphics.Item(lstGraphics.List(lstGraphics.ListIndex))
    Render

End Sub
