Attribute VB_Name = "modRenderlib"
Option Explicit
Option Compare Binary
Option Base 0


' Blending operations
Public Enum enumBlendOps
    BLEND_SOLID = 0
    BLEND_ALPHA50 = 1
    BLEND_ALPHA = 2
    BLEND_ALPHA_SIMPLE = 3
    BLEND_INVERT = 4
End Enum


' Bitplane masking modes
Public Enum enumMaskModes
    MASKMODE_NONE = 0
    MASKMODE_INDEX = 1
    MASKMODE_MASK = 2
End Enum


' Font
Public Declare Function fontLoad Lib "renderlib" (ByVal fileName As String) As Long
Public Declare Function fontGetCharWidth Lib "renderlib" (ByVal ptrFont As Long) As Long
Public Declare Function fontGetCharHeight Lib "renderlib" (ByVal ptrFont As Long) As Long
Public Declare Function fontGetSurface Lib "renderlib" (ByVal ptrFont As Long) As Long
Public Declare Sub fontDestroy Lib "renderlib" (ByVal ptrFont As Long)

' Render
Public Declare Sub renderInit Lib "renderlib" ()
Public Declare Sub renderBlit Lib "renderlib" (ByVal ptrDestSurf As Long, ByVal ptrSrcSurf As Long, ByVal X As Long, ByVal Y As Long, ByVal Width As Long, ByVal Height As Long, ByVal blendOp As enumBlendOps)
Public Declare Sub renderBlitAlphaFast Lib "renderlib" (ByVal ptrDestSurf As Long, ByVal ptrSrcSurf As Long, ByVal X As Long, ByVal Y As Long, ByVal blendOp As enumBlendOps)
Public Declare Sub renderBlitFast Lib "renderlib" (ByVal ptrDestSurf As Long, ByVal ptrSrcSurf As Long, ByVal X As Long, ByVal Y As Long)
Public Declare Sub renderBoxFill Lib "renderlib" (ByVal ptrDestSurf As Long, ByVal X As Long, ByVal Y As Long, ByVal Width As Long, ByVal Height As Long, ByVal Color As Long, ByVal blendOp As enumBlendOps)
Public Declare Sub renderBox Lib "renderlib" (ByVal ptrDestSurf As Long, ByVal X As Long, ByVal Y As Long, ByVal Width As Long, ByVal Height As Long, ByVal Color As Long, ByVal blendOp As enumBlendOps)
Public Declare Sub renderLine Lib "renderlib" (ByVal ptrDestSurf As Long, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long, ByVal Color As Long, ByVal blendOp As enumBlendOps)
Public Declare Sub renderText Lib "renderlib" (ByVal ptrDestSurf As Long, ByVal ptrFont As Long, ByVal X As Long, ByVal Y As Long, ByVal Text As String, ByVal Color As Long, ByVal blendOp As enumBlendOps)

' Surface
Public Declare Function surfaceCreate Lib "renderlib" (ByVal Width As Long, ByVal Height As Long) As Long
Public Declare Function surfaceFlipY Lib "renderlib" (ByVal srcSurf As Long) As Long
Public Declare Function surfaceGetPixel Lib "renderlib" (ByVal ptrSurface As Long, ByVal X As Long, ByVal Y As Long) As Long
Public Declare Function surfaceGetWidth Lib "renderlib" (ByVal ptrSurface As Long) As Long
Public Declare Function surfaceGetHeight Lib "renderlib" (ByVal ptrSurface As Long) As Long
Public Declare Function surfaceWriteToPNG Lib "renderlib" (ByVal ptrSurf As Long, ByVal fileName As String, ByVal Compression As Byte) As Long
Public Declare Function surfaceReadFromPNG Lib "renderlib" (ByVal fileName As String) As Long
Public Declare Sub surfaceExtract Lib "renderlib" (ByVal ptrSourceSurf As Long, ByVal ptrDestSurf As Long, ByVal X As Long, ByVal Y As Long)
Public Declare Sub surfaceFill Lib "renderlib" (ByVal ptrDestSurf As Long, ByVal Color As Long)
Public Declare Sub surfaceSetAlpha Lib "renderlib" (ByVal ptrSurf As Long, ByVal Alpha As Byte)
Public Declare Sub surfaceDestroy Lib "renderlib" (ByVal ptrSurface As Long)
Public Declare Sub surfaceClear Lib "renderlib" (ByVal ptrSurf As Long)
Public Declare Sub surfaceSetPixel Lib "renderlib" (ByVal ptrSurface As Long, ByVal X As Long, ByVal Y As Long, ByVal Color As Long)
Public Declare Sub surfaceCopyToBitmap Lib "renderlib" (ByVal ptrSrcSurf As Long, ByVal ptrBitmapBits As Long)
Public Declare Sub surfaceCopyToBitmapDouble Lib "renderlib" (ByVal ptrDestSurf As Long, ByVal ptrBitmapBits As Long, ByVal bmpWidth As Long, ByVal bmpHeight As Long)

' Bitstream
Public Declare Function bitsOpenBuffer Lib "renderlib" (ByVal ptrData As Long, ByVal dataLen As Long) As Long
Public Declare Function bitsOpenFile Lib "renderlib" (ByVal fileName As String) As Long
Public Declare Function bitsGetInt Lib "renderlib" (ByVal ptrBits As Long) As Long
Public Declare Function bitsGetShort Lib "renderlib" (ByVal ptrBits As Long) As Integer
Public Declare Function bitsGetByte Lib "renderlib" (ByVal ptrBits As Long) As Byte
Public Declare Function bitsGetBits Lib "renderlib" (ByVal ptrBits As Long, ByVal Count As Byte) As Long
Public Declare Function bitsGetAddress Lib "renderlib" (ByVal ptrBits As Long) As Long
Public Declare Function bitsEOF Lib "renderlib" (ByVal ptrBits As Long) As Long
Public Declare Function bitsSize Lib "renderlib" (ByVal ptrBits As Long) As Long
Public Declare Function bitsSeek Lib "renderlib" (ByVal ptrBits As Long, ByVal Address As Long) As Long
Public Declare Sub bitsSkipBytes Lib "renderlib" (ByVal ptrBits As Long, ByVal Count As Long)
Public Declare Sub bitsDestroy Lib "renderlib" (ByVal ptrBits As Long)

' Bitplane
Public Declare Function bitplaneLoadPlanar Lib "renderlib" (ByVal ptrBits As Long, ByVal Width As Long, ByVal Height As Long, ByVal Planes As Long) As Long
Public Declare Function bitplaneLoadChunky Lib "renderlib" (ByVal ptrBits As Long, ByVal Width As Long, ByVal Height As Long, ByVal Planes As Long) As Long
Public Declare Function bitplaneLoadAmigaSprite Lib "renderlib" (ByVal ptrBits As Long, ByVal Width As Long, ByVal Height As Long) As Long
Public Declare Function bitplaneCreate Lib "renderlib" (ByVal Width As Long, ByVal Height As Long, ByVal Planes As Long) As Long
Public Declare Function bitplaneToSurface Lib "renderlib" (ByVal ptrBP As Long, ByVal ptrMask As Long, ByVal ptrPal As Long, ByVal transColor As Long, ByVal Mode As Long) As Long
Public Declare Function bitplaneGetDataPtr Lib "renderlib" (ByVal BP As Long) As Long
Public Declare Sub bitplaneDestroy Lib "renderlib" (ByVal ptrBP As Long)

' Undo
Public Declare Sub undoInit Lib "renderlib" ()
Public Declare Sub undoSetMax Lib "renderlib" (ByVal maxUndo As Long)
Public Declare Sub undoDestroy Lib "renderlib" ()
Public Declare Sub undoDoUndo Lib "renderlib" (ByVal ptrData As Long)
Public Declare Sub undoAdd Lib "renderlib" (ByVal ptrData As Long, ByVal dataLen As Long)

' Utils
Public Declare Function getRed Lib "renderlib" (ByVal Color As Long) As Byte
Public Declare Function getGreen Lib "renderlib" (ByVal Color As Long) As Byte
Public Declare Function getBlue Lib "renderlib" (ByVal Color As Long) As Byte
Public Declare Function getAlpha Lib "renderlib" (ByVal Color As Long) As Byte
Public Declare Function createBGRA Lib "renderlib" (ByVal R As Byte, ByVal G As Byte, ByVal B As Byte, ByVal A As Byte) As Long
Public Declare Function createRGBA Lib "renderlib" (ByVal R As Byte, ByVal G As Byte, ByVal B As Byte, ByVal A As Byte) As Long
Public Declare Function byteSwapInt Lib "renderlib" (ByVal inVal As Long) As Long
Public Declare Function byteSwapShort Lib "renderlib" (ByVal inVal As Long) As Long
Public Declare Sub freeMemory Lib "renderlib" (ByVal ptrMemory As Long)
